#!/usr/local/bin/perl

#  BBS wBikkex Ver.2.7.2 2003/01/16
#  Copyright 1999-2002 Yuji OGAWA, Allright reserved. 

use strict;

require 'jcode.pl';

# =================== Œp[^̐ݒ =========================

my $bikke_version = '2.7.2';                 # vOo[W

my $tz = -9;                                 # TimeZone␳li{-9j
my $boards_file = 'bikke_boards.cgi';        # {[hݒt@C̖O
my $posterror_file = 'bikke_posterror.html'; # eG[bZ[Wt@C
my $usage_file = 'bikke_usage.html';         # t@C
my $article_max = 20000;                     # ef[^őTCY(byte)
my $sendmail = '/usr/sbin/sendmail';         # [MvO

# ==================== HTML \p̐ݒ (1) =================

# ----- u߂v{^ ----------------
my $back_button = qq!<P ALIGN="CENTER">[ <A HREF="JavaScript:history.back()">߂</A> ]</P>\n!;

# ==================== ftHgݒ̏ ==================

my $data_dir = '.';                # f[^t@CufBNg
my $post_type = 'normal';          # e^Cvinormal/separate/readonlyj
my $postcgi_dir = 'closed';        # evOufBNg
my $title = 'Bikke a little BBS';  # ^Cg
my $page = 10;                     # 1y[Wɕ\A[eBN
my $datafile_backup = 'on';        # f[^t@CۑtO('on' / 'off')
my $datafile_max = 50000;          # f[^t@C̍őTCY(byte)
my $archive = 'off';               # A[JCuL^tO('on' / 'off')
my $archive_max = 300000;          # A[JCu̍őTCY(byte)
my $cookie_life = 30;              # NbL[̗L()
my $cache_life = 10;               # y[WLbV̗L()
my $mailing = 'off';               # e[tO('on' / 'off')
my $mailing_cfg = '';              # [ݒt@C

my $bg_color    = '#FFFFFF';       # wiF
my $text_color  = '#000000';       # eLXg̐F
my $link_color  = '#004488';       # N̐F
my $vlink_color = '#553388';       # Kς݃N̐F
my $name_color  = '#0000AA';       # O\̐F
my $glay_color  = '#666666';       # O[\̐F

# ==================== f[^̓͂Ɖ ==========================

# ----- O[of[^ϐ -----
my ($method, %in, %in_text, %cookie, $board_key, $rno);
                                                 # URL擾
my $script_url = 'http://' . $ENV{'SERVER_NAME'} . $ENV{'SCRIPT_NAME'};
{
  my ($buffer, @pairs, $pair, $board);
  my ($cookies, $found, $key, $val, $clength);

  $buffer = $ENV{'QUERY_STRING'};                # ϐf[^擾
  @pairs = split(/&/, $buffer);                  # f[^ڃXg
  $method = $ENV{'REQUEST_METHOD'};              # NGXg\bh擾
  if ($method eq 'POST') {                       # POST삾...
    $clength = $ENV{'CONTENT_LENGTH'};           #   f[^擾
    error_abort("data too big.($clength bytes)") #   f[^傫߂G[
      if ($clength > $article_max);
    read(STDIN, $buffer, $clength);              #   W͂f[^擾
    push(@pairs, split(/&/, $buffer));           #   f[^ڃXgɒǉ
  }
  set_in(\@pairs);                               # ڂƃf[^̃nbV쐬
  error_abort("You must specify board name.")    # {[hw肪Ȃ΃G[
      unless ($in{'board'});
  $in{'note'} =~ s/\r+\Z//;                      # {̋s
  $in{'user'} = $ENV{'REMOTE_USER'};             # F؃[U擾
  if (0 < $in{'rno'} and $in{'rno'} < 999) {     # [e[gԍ擾,ݒ
    $rno = $in{'rno'} + 1;
  } else {
    $rno = 1;
  }

  open(FH, $boards_file)               # {[hݒt@CI[v
      or error_abort($!, "can't open $boards_file.");
  flock(FH, 1);
  $found = 0;
  while(<FH>) {                        # w肳ꂽ{[h̐ݒT
    if (m/^$in{'board'}=/) { $found = 1;  $buffer = $_;  last; }
  }
  close(FH);                           # {[hݒt@CN[Y
  error_abort("Board '$in{'board'}' is not found.")
      unless ($found);                 # Ȃ΃G[

  undef(@pairs);
  @pairs = split(/\s*,\s*/, $buffer);  # {[hݒڃXg
  $board = get_hash(\@pairs);          # ڂnbV
  $board_key = $board->{$in{'board'}}; # t@CL[

  $buffer = $ENV{'HTTP_COOKIE'};       # NbL[̓e擾
  undef(@pairs);
  @pairs = split(/;\s*/, $buffer);     # eNbL[ɕ
  $cookies = get_hash(\@pairs);        # SNbL[̃nbV
  undef(@pairs);
  @pairs = split(/&/, $cookies->{"bikke_$in{'board'}"});  # ړĨNbL[𕪊
  foreach $pair (@pairs) {             # ړĨ{[h̃NbL[lnbV
    ($key, $val) = ($pair =~ m/([^:]+):(.*)/);
    $val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;  # URIfR[h
    jcode::convert(\$val, 'sjis');     # R[hSJIS
    jcode::h2z_sjis(\$val);            # pJiSp
    $cookie{$key} = $val;
  }
  $cookie{'www'}  = $cookie{'www'}  || 'http://';  # ftHgl

  # --- {[h̃p[^ŃftHg㏑ݒ
  $data_dir = $board->{'data_dir'} if (defined($board->{'data_dir'}));
  $post_type = lc($board->{'post_type'}) if ($board->{'post_type'});
  $postcgi_dir = $board->{'postcgi_dir'} if (defined($board->{'postcgi_dir'}));
  $page         = $board->{'page'}        if ($board->{'page'});
  $title        = $board->{'title'}       if (defined($board->{'title'}));
  $datafile_backup = lc($board->{'data_backup'}) if ($board->{'data_backup'});
  $datafile_max = $board->{'data_max'}    if ($board->{'data_max'});
  $archive      = lc($board->{'archive'}) if ($board->{'archive'});
  $archive_max  = $board->{'archive_max'} if ($board->{'archive_max'});
  $cookie_life  = $board->{'cookie_life'} if (defined($board->{'cookie_life'}));
  $cache_life   = $board->{'cache_life'}  if (defined($board->{'cache_life'}));
  if(defined($board->{'mailing_cfg'})) {
    $mailing = 'on';
    $mailing_cfg = $board->{'mailing_cfg'};
    $mailing_cfg = "$data_dir/$mailing_cfg" # ΃pXȂdata_dir
      unless ($mailing_cfg =~ m!^(/|[a-zA-Z]:)!);
  }
  $bg_color    = $board->{'bg_color'}    if (defined($board->{'bg_color'}));
  $text_color  = $board->{'text_color'}  if (defined($board->{'text_color'}));
  $link_color  = $board->{'link_color'}  if (defined($board->{'link_color'}));
  $vlink_color = $board->{'vlink_color'} if (defined($board->{'vlink_color'}));
  $name_color  = $board->{'name_color'}  if (defined($board->{'name_color'}));
  $glay_color  = $board->{'glay_color'}  if (defined($board->{'glay_color'}));
}

# --- t@Cl[̐ݒ
my $titlefile_name  = "$data_dir/${board_key}_title.html";  # ^Cgt@C
my $datafile_name   = "$data_dir/${board_key}_data.cgi";    # f[^t@C
my $new_datafile_name = "$data_dir/new_${board_key}_data.cgi"; # Vf[^
my $old_datafile_name = "$data_dir/old_${board_key}_data.cgi"; # f[^
my $deletefile_name = "$data_dir/${board_key}_delete.cgi";  # 폜ԍt@C
my $new_deletefile_name = "$data_dir/new_${board_key}_delete.cgi"; # V폜ԍ
my $archive_name    = "$data_dir/${board_key}_archive.cgi"; # A[JCu
my $arcdelete_name  = "$data_dir/${board_key}_arcdel.cgi";  #  V 폜ԍ
my $pwdfile_name    = "$data_dir/${board_key}_pwd.cgi";     # pX[h
my $postcgi = "$postcgi_dir/$in{'board'}_post.cgi";         # e Prog.

# ==================== HTML \p̐ݒ (2) =================

# ----- HTTPwb_ ---------------
my $cexpire = get_gmtdate(time() + 60 * $cache_life); # y[WLvZ
my $http_header = "Content-type: text/html\nExpires: $cexpire\n\n";
# ----- NbL[ΉHTMLwb_ ---
my $html_header_cookie = <<"EOT";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
        "http://www.w3.org/TR/html4/loose.dtd">
<HTML LANG="ja">
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=Shift_JIS">
<TITLE>$title</TITLE>
<SCRIPT LANGUAGE="JavaScript">
<!--
function set_cookie() {
  var d = new Date();
  d.setTime(d.getTime() + 1000 * 60 * 60 * 24 * $cookie_life);
  document.cookie = 'bikke_$in{'board'}=' +
  'name:' + escape(document.inputform.name.value) + 
  '&mail:' + escape(document.inputform.mail.value) + 
  '&www:' + escape(document.inputform.www.value) + 
  '&delkey:' + escape(document.inputform.delkey.value) + 
  '; expires=' + d.toGMTString();
  alert('NbL[̐ݒ葀슮.');
}
// -->
</SCRIPT>
</HEAD>
EOT
# ----- ʏHTMLwb_ ---------
my $html_header = <<"EOT";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
        "http://www.w3.org/TR/html4/loose.dtd">
<HTML LANG="ja">
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=Shift_JIS">
<TITLE>$title</TITLE>
</HEAD>
EOT
# ----- NbL[ΉHTML<BODY> ---
my $html_body_cookie = qq!<BODY BGCOLOR="$bg_color" TEXT="$text_color" LINK="$link_color" VLINK="$vlink_color" onLoad="if(document.inputform.name.value.indexOf('%u') >= 0) document.inputform.name.value = unescape(document.inputform.name.value);">\n!;
# ----- ʏHTML<BODY> ---------
my $html_body = qq!<BODY BGCOLOR="$bg_color" TEXT="$text_color" LINK="$link_color" VLINK="$vlink_color">\n!;
# ----- HTML̏I -------------
my $html_end = "</BODY>\n</HTML>\n";

# ----- e{^ ---------------
my $post_button = qq|<P ALIGN="CENTER"><A HREF="$postcgi?rno=$rno">m e n</A></P>\n|;
# ----- eptH[ -----------
my $input_form = <<"EOT";
<!-- input form -->
<FORM METHOD="post" ACTION="$script_url?board=$in{'board'}" ID="inputform" NAME="inputform">
  <TABLE WIDTH="100%" BORDER="0">
    <TR>
      <TD ALIGN="RIGHT"><LABEL FOR="name" ACCESSKEY="N"><B><FONT COLOR="$name_color">O</FONT></B></LABEL></TD>
      <TD><INPUT TYPE="text" ID="name" NAME="name" SIZE="50" VALUE="$cookie{'name'}"></TD>
    </TR>
    <TR>
      <TD ALIGN="RIGHT"><LABEL FOR="mail" ACCESSKEY="M"><B><FONT COLOR="$name_color">[</FONT></B></LABEL></TD>
      <TD><INPUT TYPE="text" ID="mail" NAME="mail" SIZE="50" VALUE="$cookie{'mail'}"></TD>
    </TR>
    <TR>
      <TD ALIGN="RIGHT"><LABEL FOR="www" ACCESSKEY="W"><B><FONT COLOR="$glay_color">WWWTCg</FONT></B></LABEL></TD>
      <TD><INPUT TYPE="text" ID="www" NAME="www" SIZE="70" VALUE="$cookie{'www'}"></TD>
    </TR>
    <TR>
      <TD ALIGN="RIGHT"><LABEL FOR="subj" ACCESSKEY="S"><B>\\</B></LABEL></TD>
      <TD NOWRAP><INPUT TYPE="text" ID="subj" NAME="subj" SIZE="50">
      @<LABEL FOR="delkey" ACCESSKEY="D"><B><FONT COLOR="$glay_color">폜L[</FONT></B></LABEL>
        <INPUT TYPE="PASSWORD" ID="delkey" NAME="delkey" SIZE="10" VALUE="$cookie{'delkey'}"></TD>
    </TR>
    <TR>
      <TD ALIGN="RIGHT"><LABEL FOR="note" ACCESSKEY="T"><B>{</B></LABEL></TD>
      <TD><TEXTAREA ID="note" NAME="note" COLS="70" ROWS="5" WRAP="PHYSICAL"></TEXTAREA></TD>
    </TR>
    <TR>
      <TD ALIGN="RIGHT"><LABEL FOR="link" ACCESSKEY="U"><B><FONT COLOR="$glay_color">QURL</FONT></B></LABEL></TD>
      <TD><INPUT TYPE="text" ID="link" NAME="link" SIZE="70" VALUE="http://"></TD>
    </TR>
    <TR>
      <TD ALIGN="RIGHT">@</TD>
      <TD>
        <INPUT TYPE="submit" VALUE="@@e@">
        <INPUT TYPE="RESET" VALUE="NA">
        @@<INPUT TYPE="button" VALUE="NbL[ݒ" onClick="set_cookie();">
        @@<A HREF="$script_url?board=$in{'board'}&rno=$rno">[ \\XV ]</A>
        @@<A HREF="$script_url?board=$in{'board'}&command=Usage">[  ]</A>
      </TD>
    </TR>
  </TABLE>
  <INPUT TYPE="hidden" NAME="command" VALUE="Post">
  <INPUT TYPE="hidden" NAME="rno" VALUE="$rno">
</FORM>
EOT
# ----- ŉɕ\tH[ ------
my $sub_form = <<"EOT";
<!-- sub form -->
<TABLE WIDTH="100%" BORDER="0">
  <TR>
    <TD ALIGN="LEFT"> 
      <FORM METHOD="post" ACTION="$script_url?board=$in{'board'}" ID="delform" NAME="delform">
        <INPUT TYPE="submit" VALUE="A[eBN폜">
        <LABEL FOR="delno" ACCESSKEY="B"><B>@ԍ</B></LABEL>
        <INPUT TYPE="text" ID="delno" NAME="delno" SIZE="6">
        <LABEL FOR="key" ACCESSKEY="K"><B>@L[</B></LABEL>
        <INPUT TYPE="PASSWORD" ID="key" NAME="key" SIZE="10">
        <INPUT TYPE="hidden" NAME="command" VALUE="UserDel">
        <INPUT TYPE="hidden" NAME="rno" VALUE="$rno">
      </FORM>
    </TD>
    <TD ALIGN="RIGHT"><A HREF="$script_url?board=$in{'board'}&command=Admin">[ǗҗptH[]</A></TD>
  </TR>
</TABLE>
EOT
# ----- m[gƃm[g̋؂ --------
my $delimiter = qq!<HR WIDTH="93%" SIZE="1" NOSHADE>\n!;
# ----- u{[h\ɖ߂v{^ ----
my $disp_button = qq!<P ALIGN="CENTER">[ <A HREF="$script_url?board=$in{'board'}">{[h\\ɖ߂</A> ]</P>\n!;
# ----- BikkẽS -------------------
my $bikke_logo = qq!<P ALIGN="RIGHT"><B><FONT COLOR="$name_color" SIZE="+1">Bikke</FONT></B> ver.$bikke_version<BR><SMALL>by Yuji at 2003, OEKAKI-STREET</SMALL></P>\n!;


# ==================== C ======================================

if ($method eq 'POST') {                   # |Xg̗ނ
  if ($in{'command'} eq 'Post') {              # eR}h...
    post();                                    #   e
    post_mail() if($mailing eq 'on');          #   KvȂ烁[
    disp();                                    #   \
  } elsif ($in{'command'} eq 'ChangePwd') {    # pX[hύXR}h...
    ch_pwd();                                  #   pX[hύX
  } elsif ($in{'command'} eq 'AdminDel') {     # Ǘҗp폜R}h...
    admin_del();                               #   A[eBN폜iǗҁj
  } elsif ($in{'command'} eq 'UserDel') {      # [U[p폜R}h...
    user_del();                                #   A[eBN폜i[Uj
  } else {                                     # ǂłȂ΃G[
    error_abort('command error', 'R}hw܂͖R}hł.');
  }
} else {                                   # GET̗ނ
  if ($in{'command'} eq 'Admin') {             # Ǘ҃tH[\R}h...
    admin();                                   #   Ǘ҃tH[\
  } elsif ($in{'command'} eq 'Usage') {        # \R}h...
    disp_html($usage_file);                    #   \
  } else {                                     # ǂłȂ...
    disp();                                    #   \̂
  }
}
exit(0);                                   # I


# ==================== Tu[` Level 1 ========================

# -------------------- e ----------------------------------------
sub post {
  my ($article, $content, @pairs, $line);
  my ($no, $date, $newfile);

  if ($post_type ne 'normal') {        # e^CvʏłȂ΃G[
    error_abort('Cannot post this way.', '̕@ł̓e͏o܂.');
  }

  foreach (qw(name mail subj note)) {  # Kvȗ܂Ă邩`FbN
    disp_html($posterror_file) if ($in{$_} eq '');
  }

  $date = get_datetime();              # ݂̓tƎ擾

  unless (-e $datafile_name) {  $newfile = 1;  }  # VKt@CtO
                        else {  $newfile = 0;  }
  if ($newfile) {                      # VKt@Cւ݂̏Ȃ...
    $no = 1;                           #   A[eBNԍ 1
  } else {                             # łȂ...
    open(OLDDATA, $datafile_name)      #   f[^t@CI[v
        or error_abort("can't open $datafile_name.");
    flock(OLDDATA, 1);                 #   t@CbN
    $line = <OLDDATA>;                 #   擪sǂݍ
    close(OLDDATA);                    #   f[^t@CN[Y
    @pairs = split(/"/, $line);        #   ڃXg
    $article = get_hash(\@pairs);      #   A[eBNpnbV
    if ( $in{'note'} ne $article->{'note'}  # Õf[^Ɠ`FbN
         or $in{'subj'} ne $article->{'subj'}
         or $in{'name'} ne $article->{'name'}
         or $in{'mail'} ne $article->{'mail'} ) {
      $no = $article->{'no'} + 1;      #   VKA[eBN̔ԍ𓾂
    } else { disp_html($posterror_file); }  # ȂG[
  }

  $in{'host'} = get_hostname();      # zXg擾
  # VKA[eBNۑpsf[^
  $content = sprintf(qq!no=$no"date=$date"host=%s"user=%s"name=%s"mail=%s"www=%s"link=%s"subj=%s"delkey=%s"note=%s!, @in{'host', 'user', 'name', 'mail', 'www', 'link', 'subj', 'delkey', 'note'});
  if ((-s $archive_name) >= $archive_max) {  # A[JCu傫߂G[
    error_abort("Archive file too big.", "Please contact board manager.",
                "{[hǗ҂ɘAĂ.");
  }
  if (-e "$new_datafile_name") {        # ʃvZXݒ`FbN
    error_abort("post method is busy.", "ݑ삪؂Ă܂.",
                "ԂuĂxĂ݂Ă.");
  }
  open(NEWDATA, ">$new_datafile_name")  # Vf[^t@C쐬
    or error_abort("can't create $new_datafile_name.");
  flock(NEWDATA, 2);                    # t@CbN
  print NEWDATA "$content\n";           # 擪ɐVKA[eBNۑ

  unless ($newfile) {                   # t@CȂ...
    open(OLDDATA, "$datafile_name")     #   t@CI[v
        or error_abort($!, "can't open $datafile_name");
    flock(OLDDATA, 2);                  #   t@CbN
    seek(OLDDATA, 0, 0);                #   t@C擪Ɂi΍j
    seek(NEWDATA, 0, 2);                #   VKt@CɁiVj
    while(<OLDDATA>) {                  #   Vt@CɓeRs[
      last if (tell(NEWDATA) > $datafile_max);  # őTCYz珑Ȃ
      print NEWDATA $_;                 #   Vt@C1s
    }
    close(OLDDATA);                     #   f[^t@CN[Y
    if ($datafile_backup eq 'on') {           # obNAbvtO'on'Ȃ
      unlink($old_datafile_name)                # obNAbv΍폜
        if (-e $old_datafile_name);
      rename($datafile_name, $old_datafile_name)    # t@C̖OύX
          or error_abort($!, "can't rename old $datafile_name.");
    } else {                                  # obNAbvtO'off'Ȃ
      unlink($datafile_name)                        # t@C폜
          or error_abort($!, "can't delete $datafile_name.");
    }
  }
  close(NEWDATA);                       # Vf[^t@CN[Y
  rename("$new_datafile_name", $datafile_name)  # Vt@Cl[
      or error_abort("can't rename new $datafile_name.");
  if ($archive eq 'on') {               # A[JCuL^tO'on'Ȃ
    open(ARC, ">>$archive_name")        # A[JCut@CǋLpɃI[v
      or error_abort("can't open $archive_name.");
    flock(ARC, 2);
    seek(ARC, 0, 2);                    # t@CɃV[Ni΍j
    print ARC "$content\n";             # A[JCuɐVKA[eBNۑ
    close(ARC);
  }
}

# -------------------- \ ----------------------------------------
sub disp {
  my (%deleted, @articles, $article, @pairs, $pos, $i, $no);
  my ($more_flag, $next_pos, $prev_pos, $duser, $dwww, $dlink);

  if (-e $deletefile_name) {             # 폜ԍt@C݂Ă
    open(DELFILE, $deletefile_name)
        or error_abort("can't open $deletefile_name");
    flock(DELFILE, 1);
    while(<DELFILE>) {  chomp($_);  $deleted{$_} = 1;  } # 폜σnbV쐬
    close(DELFILE);
  }

  if (-e $datafile_name) {               # f[^t@C݂Ă
    $pos = $in{'pos'};                      # \Jnʒu擾
    open(DATAFILE, $datafile_name)          # f[^t@CI[v
        or error_abort($!, "can't open $datafile_name.");
    flock(DATAFILE, 1);                     # t@CbN
    for ($i = 0; $i < $pos; $i++) {         # wʒu܂œǂݔ΂
      $_ = <DATAFILE>;
    }
    $next_pos = $pos;
    $more_flag = 0;
    while(<DATAFILE>) {                     # A[eBNǂݍ
      if (@articles >= $page) {               # 1y[Wǂ񂾂...
        $more_flag = 1;                       #   y[W݃tO𗧂Ă
        last;                                 #   [vEo
      }
      $next_pos++;                                 # y[W̐擪ʒu
      @pairs = split(/"/, $_);                     # 1sf[^ڂɕ
      $article = get_hash(\@pairs);                # ڂ̃nbV쐬
      next if ($deleted{$article->{'no'}});        # 폜ς݂͓ǂݔ΂
      push(@articles, $article);                   # A[eBNXg
    }
    close(DATAFILE);                        # f[^t@CN[Y
  }

  print $http_header;                       # wb_o
  if ($post_type eq 'normal') {
    print $html_header_cookie, $html_body_cookie;
  } else {
    print $html_header, $html_body;
  }
  if (-e $titlefile_name) {                 # ^Cgt@C...
    open(TITLE_FILE, $titlefile_name)       #   t@CI[v
        or error_abort($!, "can't open $titlefile_name.");
    print <TITLE_FILE>;                     #   ^Cg̓eo
    close(TITLE_FILE);                      #   t@CN[Y
  } else {                                  # Ȃ...
    print "<H1>$title</H1>\n";              #   ftHg̃^Cg\
  }
  print qq!<FONT COLOR="#FF0000"> Ǘ҃pX[hݒ </FONT>\n!
      unless (-e $pwdfile_name);            # pX[hݒ̌x\

  if ($post_type eq 'normal') {             # e^CvʏȂ...
    print $input_form;                      #   eptH[\
  } elsif ($post_type eq 'separate') {      # e^CvȂ...
    print $post_button;                     #   e{^\
  }
  print "<HR>\n";
  if ($pos > 0) {                                # Oy[W{^
    $prev_pos = $pos - $page;
    $prev_pos = 0 if ($prev_pos < 0);
    $no = $articles[0]->{'no'};
    $i = 0;
    while($prev_pos > 0) {                       # Oy[W擪ʒu߂
      $no++;
      if ($deleted{$no})  {  $prev_pos--;  }
      elsif ($i >= $page) {  last;  }
      else                {  $i++;  }
    }
    print qq!<P ALIGN="CENTER"><A HREF="$script_url?board=$in{'board'}&pos=$prev_pos">[Vy[W֐iށ]</A></P>!;
    print $delimiter;                            # ؂\
  }
  print "<!-- Articles -->\n";
  # --- eA[eBN\ ---
  foreach $article (@articles) {
    $no = sprintf("%05d", $article->{'no'});     # ԍ
    $article->{'note'} =~ s/\r/<BR>\n/g;         # {̉s<BR>
    if ($article->{'user'}) {
      $duser = "($article->{'user'})";           # F؃[U
    } else { $duser = ''; }
    if ($article->{'www'}) {                     # WWWTCgURL
      $dwww =  " WebSite= <A HREF=\"$article->{'www'}\">$article->{'www'}</A>";
    } else { $dwww = ''; }
    if ($article->{'link'}) {                    # QURL
      $dlink = "<P>[Reference URL = <A HREF=\"$article->{'link'}\">$article->{'link'}</A>]</P>\n";
    } else { $dlink = ''; }

    print <<"EOT";
      <P>No.$no at $article->{'date'}<BR>
      from <B><FONT COLOR="$name_color">$article->{'name'}</FONT></B>
      $duser
      [ Mail= <A HREF="mailto:$article->{'mail'}">$article->{'mail'}</A>$dwww ]
      </P>
      <P><B>$article->{'subj'}</B></P>
      <BLOCKQUOTE>
        <P>$article->{'note'}</P>
        $dlink
      </BLOCKQUOTE>
      $delimiter
EOT
  }

  if ($more_flag) {                              # y[W{^
    print qq!<P ALIGN="CENTER"><A HREF="$script_url?board=$in{'board'}&pos=$next_pos">[Ây[W֐iށ]</A></P>\n!;
    print $delimiter;                            # ؂\
  }
  print $sub_form;
  print "<HR>\n";
  print $bikke_logo;                             # BikkẽS\
  print $html_end;                               # HTMLI
}

# -------------------- ǗҗptH[\ ----------------------
sub admin {
  print $http_header, $html_header, $html_body;  # wb_o

  print <<"EOT";
<H1 ALIGN="CENTER">
  $title ǗҗptH[
</H1>
<HR>
<H2>A[eBN폜</H2>
<FORM METHOD="post" ACTION="$script_url?board=$in{'board'}" NAME="delform">
  <P>폜A[eBNԍ
    <INPUT TYPE="text" NAME="delno" SIZE="10">
    @Ǘ҃pX[h
    <INPUT TYPE="PASSWORD" NAME="password" SIZE="20">
  </P>
  <P>
    <INPUT TYPE="submit" VALUE="폜 s">
  </P>
  <INPUT TYPE="hidden" NAME="command" VALUE="AdminDel">
</FORM>
<HR>
<H2>Ǘ҃pX[ho^^ύX</H2>
<FORM METHOD="post" ACTION="$script_url?board=$in{'board'}" NAME="pwdform">
  <P>݂̃pX[h
    <INPUT TYPE="PASSWORD" NAME="old_pwd" SIZE="20">
  </P>
  <P>VpX[h
    <INPUT TYPE="PASSWORD" NAME="new_pwd" SIZE="20">
    @VpX[hiēxj
    <INPUT TYPE="PASSWORD" NAME="new_pwd2" SIZE="20">
  </P>
  <P> 
    <INPUT TYPE="submit" VALUE="o^^ύX s">
    <INPUT TYPE="hidden" NAME="command" VALUE="ChangePwd">
  </P>
</FORM>
<HR>
<P ALIGN="RIGHT">
Bikke board manager form ver.1.0<BR>
</P>
EOT
  print $html_end;                               # HTMLI
}

# -------------------- pX[ho^^ύX ------------------------
sub ch_pwd {
  my ($password, $salt);

  srand(time()^($$+($$<<15)));                 # 
  if ($in{'new_pwd'} ne $in{'new_pwd2'}) {     # ̐VpX[hׂ
    error_abort('retype is different from new password.',
                'VpX[hē͂ƐHĂ܂.');
  }
  if (length($in{'new_pwd'}) < 6) {            # pX[hZ߂G[
    error_abort('password needs 6 charactor or more.',
                'pX[h6ȏKvł.');
  }
  if (-e $pwdfile_name) {                      # pX[ht@C...
    check_pwd($in{'old_pwd'});                 # pX[hmF
  }
  $salt = pack('CC', 65 + int(rand(26)), 65 + int(rand(26)));  # ϊL[쐬
  $password = crypt($in{'new_pwd'}, $salt);    # VpX[hÍ
  open(FH, ">$pwdfile_name")
     or error_abort("can't write $pwdfile_name",
                    'pX[ht@Co͗pɃI[vo܂.');
  flock(FH, 2);
  print FH "$password\n";                      # VpX[hۑ
  close(FH);

  show_message('new password is accepted.', 'VpX[ĥ܂.');
}

# -------------------- A[eBN폜iǗҁj ------------------
sub admin_del {
  if (-e $pwdfile_name) {                    # pX[ht@C...
    check_pwd($in{'password'});              #   pX[hmF
  } else {                                   # Ȃ΃G[
    error_abort("password file not found.",
                'pX[ht@C܂.',
                'ǗҗppX[ho^Ă.');
  }
  del($in{'delno'}, '&admin');   # Ǘғtō폜[`Ăяo
  show_message('delete success.', "A[eBN $in{'delno'} 폜.");
}

# -------------------- A[eBN폜i[U[j ----------------
sub user_del {
  del($in{'delno'}, $in{'key'});
  disp();
}

# -------------------- [ ----------------------------------
sub post_mail {
  my($from, @to, @cc, @bcc, $body);

  open(CFG, $mailing_cfg) or error_abort($!, "cannot open $mailing_cfg");
  while(<CFG>) {                                # [ݒt@Cǂ
    if(m/^from:\s*(\S+)/i) { $from = $1; }      #   wb_ڂǂ
    elsif(m/^to:\s*(\S+)/i)  { push(@to, $1); }
    elsif(m/^cc:\s*(\S+)/i)  { push(@cc, $1); }
    elsif(m/^bcc:\s*(\S+)/i) { push(@bcc, $1); }
    elsif(m/^-/) { $body = join('', <CFG>); }   #   c͖{
  }
  close(CFG);
  error_abort('maling configration is not enough.',
              '[̐ݒ肪sł.') if($from eq '' or @to <= 0);
  jcode::convert(\$body, 'jis');               # {JISR[h
  foreach ('name', 'subj', 'note', 'link') {   # v[Xz_ϊ
    jcode::convert(\$in_text{$_}, 'jis');
    $body =~ s/%%%$_%%%/$in_text{$_}/;
  }
  $body =~ s/\n+\Z//;                          # {̋s
  open(MAIL, "| $sendmail -t -oi")             # sendmail ɏo
         or error_abort($!, "cannot open $sendmail.");
  print MAIL "From: $from\n";
  print MAIL 'To: '  . join(', ', @to) . "\n" if(@to > 0);
  print MAIL 'Cc: '  . join(', ', @cc) . "\n" if(@cc > 0);
  print MAIL 'Bcc: ' . join(', ', @bcc) . "\n" if(@bcc > 0);
  print MAIL "Subject: New article on board[$in{'board'}] with Bikke\n";
  print MAIL "\n";
  print MAIL "$body\n";
  close(MAIL);
}


# ==================== Tu[` Level 2 ========================

# ----- ̓f[^ %in ɃZbg
# set_in(<ڃXg̎Q>);
# ex. set_in(\@list);
sub set_in {
  my ($pairs, $pair, $key, $val);
  $pairs = shift(@_);
  foreach $pair(@$pairs) {
    ($key, $val) = ($pair =~ m/([^=]+)=(.*)/);
    $val =~ tr/+/ /;                   # '+'Xy[XɃfR[h
    $val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;  # URIfR[h
    jcode::convert(\$val, 'sjis');     # R[hSJIS
    jcode::h2z_sjis(\$val);            # pJiSp
    $in_text{$key} = $val;             # v[eLXgf[^ۑ
    html_text(\$val);                  # HTMLpeLXg
    $in{$key} = $val;                  # nbVɒlZbg
  }
  $in{'note'} =~ s/\r\n/\r/g;          # DOSs<cr><lf><cr>
  $in{'note'} =~ tr/\n/\r/;            # UNIXs<lf><cr>
  $in_text{'note'} =~ s/\r\n/\n/g;     # DOSs<cr><lf><lf>
  $in_text{'note'} =~ tr/\r/\n/;       # Macs<cr><lf>
  foreach ('www', 'link') {            # URL̃ftHglr
    if ($in{$_} eq 'http://') { $in_text{$_} = $in{$_} = ''; }
  }
}

# ----- yAf[^̃XgănbVɃZbg
# get_hash(<ڃXg̎Q>);
# ex. get_hash(\@list);
# ߂l͐VɍnbV̎Q
sub get_hash {
  my ($hash, $pairs);
  $pairs = shift(@_);
  %$hash = map { m/([^=]+)=(.*)/ } @$pairs;  # ȂnbVɒlZbg
  return($hash);
}

# ----- Ǘ҃pX[h`FbN
# check_pwd(<͂ꂽ>);
# ex. check_pwd($input_str);
# F؂ɎsƃG[AȂ炻̂܂܋A
sub check_pwd {
  my ($password, $input);
  $input = shift(@_);

  open(FH, $pwdfile_name) or error_abort("can't open $pwdfile_name.");
  flock(FH, 1);
  $password = <FH>;                               # pX[hǂݍ
  chomp($password);
  close(FH);
  if (crypt($input, $password) ne $password) {    # pX[hF
    error_abort("incorrect password.", 'pX[hF؂Ɏs܂.');
  }
}

# ----- A[eBN폜
# del(<폜A[eBN̔ԍ>, <폜L[>);
# ex. del(150, 'mydel$');
# 폜L['&admin'͊Ǘҍ폜ƌȂAL[ƍsȂ
# 폜ɎsƃG[AƂ̂܂܋A
sub del {
  my (%deleted, @nolist, $password, $minno, $delno, $delkey, $found_flag);
  my ($lastline, $akey, @pairs, $article);

  $delno = shift(@_);                # 폜A[eBNԍ
  $delno = abs($delno);              #   0tĂ肵Ă悤
  $delkey = shift(@_);               # 폜L[
  if (-e $deletefile_name) {         # 폜ԍL^t@C݂Ă...
    open(FH, "$deletefile_name")
        or error_abort("can't open $deletefile_name.");
    flock(FH, 1);
    while(<FH>) {  chomp($_);  $deleted{$_} = 1;  } # 폜ԍnbVɓǂ
    close(FH);
  }
  open(DATAFILE, $datafile_name)      # f[^t@CI[v
      or error_abort("can't open $datafile_name.");
  flock(DATAFILE, 1);                 # t@CbN
  $found_flag = 0;
  while (<DATAFILE>) {
    if (m/no=$delno"/) {
      $found_flag = 1;
      @pairs = split(/"/, $_);        # 
      $article = get_hash(\@pairs);
      $akey = $article->{'delkey'};
      while(<DATAFILE>) { $lastline = $_; }   # Ō̍s܂œǂݔ΂
      last;
    }
    $lastline = $_;                           # Ō̍s𓾂
  }
  @pairs = split(/"/, $lastline);     # 
  $article = get_hash(\@pairs);
  $minno = $article->{'no'};          # ŏԍ𓾂
  close(DATAFILE);                    # f[^t@CN[Y

  if ($deleted{$delno}) {                          # ɍ폜ς݂Ȃ...
    error_abort("no.$delno is already deleted.");  #   G[
  } elsif ($found_flag == 0) {                     # ȂĂ...
    error_abort("no.$delno is not found.");        #   G[
  } elsif ($delkey ne '&admin' and                 # Ǘҍ폜ȊO
           ($akey ne $delkey or $akey eq '')) {    # L[Ⴄ󔒂ł...
    error_abort("incorrect delete key.", "폜L[v܂."); # G[
  } else {
    $deleted{$delno} = 1;                  # 폜ԍɒǉ
    @nolist = sort { $a <=> $b }           # ŏԍ̂ĂăXg쐬
              grep { $_ >= $minno } keys(%deleted);
    if (-e "new_$deletefile_name") {       # vZX폜`FbN
      error_abort("delete method is busy.", "폜؂Ă܂.",
                  "ԂuĂ蒼Ă݂Ă.");
    }
    open(FH, ">$new_deletefile_name")      # 폜ԍL^t@CVKɍ쐬
        or error_abort("can't create new_$deletefile_name.");
    flock(FH, 2);
    foreach (@nolist) {  print FH "$_\n";  }  # 폜ԍۑ
    close(FH);
    if ($archive eq 'on') {         # A[JCuL^tO'on'Ȃ...
      open(FH, ">>$arcdelete_name") #   A[JCup폜ԍt@CI[v
          or error_abort("can't append $arcdelete_name.");
      flock(FH, 2);
      print FH "$delno\n";    #   폜ԍǉ
      close(FH);
    }
    unlink($deletefile_name) if (-e $deletefile_name);
    rename("$new_deletefile_name", $deletefile_name)
        or error_abort("can't rename new $deletefile_name");
  }
}

# ----- HTMLpeLXg
sub html_text {
  my $val = shift(@_);

  $$val =~ s/&/&amp;/g;               # ^O̖
  $$val =~ s/"/&quot;/g;
  $$val =~ s/'/&#39;/g;
  $$val =~ s/</&lt;/g;
  $$val =~ s/>/&gt;/g;
  $$val =~ s/\t/&nbsp&nbsp;/g;        # TABXy[X2Rɕϊ
}

# ----- ݂̓tƎ\𓾂
sub get_datetime {
  my ($year, $month, $day, $hour, $min);

#  ($min, $hour, $day, $month, $year) = (localtime(time))[1, 2, 3, 4, 5];
  ($min, $hour, $day, $month, $year) = (gmtime(time-$tz*60*60))[1, 2, 3, 4, 5];
  $year += 1900;
  $month++;
  return sprintf("%04d/%02d/%02d %02d:%02d", $year, $month, $day, $hour, $min);
}

# ----- RFC1123`GMTt𓾂
# get_gmtdate(<timel>);
# ex. get_gmtdate(time());
sub get_gmtdate {
  my @wdays = qw(Sun Mon Tue Wed Thu Fri Sat);
  my @mons  = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Out Nov Dec);
  my ($year, $month, $day, $wday, $hour, $min, $sec);

  my $vtime = shift(@_);
  
  ($sec, $min, $hour, $day, $month, $year, $wday) =
      (gmtime($vtime))[0, 1, 2, 3, 4, 5, 6];
  $year += 1900;
  return sprintf("%s, %02d %s %04d %02d:%02d:%02d GMT",
                 $wdays[$wday], $day, $mons[$month], $year, $hour, $min, $sec)
}

# ----- [gzXg𓾂
sub get_hostname {
  my ($addr, $host);

  $addr = $ENV{'REMOTE_ADDR'};
  $host = $ENV{'REMOTE_HOST'};
  if ($host eq '') {
    unless ($host = gethostbyaddr(pack('C4', split(/\./,$host)), 2)) {
      $host = $addr;
    }
  }
  return($host);
}


# ==================== Tu[` Level 3 ========================

# ----- G[\ďI
# error_abort(<bZ[W̃Xg>...);
# ex. error_abort("file not found!", "can't open $filename");
sub error_abort {
  my $message = shift(@_);
  print "Content-type: text/html\n\n";
  print "<HTML>\n<HEAD>\n<TITLE>Error on Bikke</TITLE>\n</HEAD>\n<BODY>\n";
  print "<H1>Error on Bikke : $message</H1>\n";  # ŏ̃bZ[W
  foreach (@_) {  print "<P>$_</P>\n";  }        # cS\
  print $back_button;                            # u߂v{^\
  print "</BODY>\n<HTML>";
  exit(0);
}

# ----- HTML ŃbZ[Wo
# show_message(<bZ[W̃Xg>...);
# ex. show_message("done.", "command is complete.");
sub show_message {
  my $message = shift(@_);
  print $http_header, $html_header, $html_body;
  print "<H1 ALIGN=\"CENTER\">Bikke: $message</H1>\n";   # ŏ̃bZ[W
  foreach (@_) { print "<P ALIGN=\"CENTER\">$_</P>\n"; } # cS\
  print $back_button;      # u߂v{^
  print $disp_button;      # u{[h\ɖ߂v{^
  print $html_end;
}

# ----- w HTML t@CuEUɑďI
# disp_html(<HTMLt@C>);
# ex. disp_html("posterror.html");
sub disp_html {
  my $file_name = shift(@_);
  open(FH, $file_name) or error_abort($!, "can't open $file_name.");
  print "Content-type: text/html\n\n";
  print <FH>;             # t@C̓eS\
  close(FH);
  exit(0);
}

