#!/usr/local/bin/perl
# Bikke etH[^Cvp evO
# ver.2.1  for Bikke ver.2.7.2  2003/01/16  by Yuji

use strict;

require '../jcode.pl';

# ----- {ݒl
my $tz = -9;                                    # TimeZone␳li{-9j
my $bikke = '../bikke.cgi';                     # Bikke{̂̏ꏊƖO
my $boards_file = '../bikke_boards.cgi';        # {[hݒt@C̖O
my $posterror_file = '../bikke_posterror.html'; # eG[bZ[Wt@C
my $article_max = 20000;                        # ef[^őTCY(byte)
my $sendmail = '/usr/sbin/sendmail';            # [MvO

# ----- {[hݒftHgl
my $data_dir = '..';                 # f[^t@CufBNg
my $title = 'Bikke a little BBS';    # ^Cg
my $datafile_backup = 'on';          # f[^t@C̕ۑtO('on' / 'off')
my $datafile_max = 50000;            # f[^t@C̍őTCY(byte)
my $archive = 'off';                 # A[JCuL^tO('on' / 'off')
my $archive_max = 300000;            # A[JCu̍őTCY(byte)
my $cookie_life = 30;                # NbL[̗L()
my $mailing = 'off';                 # e[tO('on' / 'off')
my $mailing_cfg = '';                # [ݒt@C

my $bg_color    = '#FFFFFF';         # wiF
my $text_color  = '#000000';         # eLXg̐F
my $link_color  = '#004488';         # N̐F
my $vlink_color = '#553388';         # Kς݃N̐F
my $name_color  = '#0000AA';         # O\̐F
my $glay_color  = '#666666';         # O[\̐F

# ==================== f[^̓͂Ɖ ==========================

my ($method, %in, %in_text, %cookie, $board_key, $rno);
                                                 # URL擾
my $script_url = 'http://' . $ENV{'SERVER_NAME'} . $ENV{'SCRIPT_NAME'};
{
  my ($buffer, @pairs, $pair, $board);
  my ($cookies, $found, $key, $val, $clength);

  $buffer = $ENV{'QUERY_STRING'};                  # ϐf[^擾
  @pairs = split(/&/, $buffer);                    # f[^ڃXg
  $method = $ENV{'REQUEST_METHOD'};                # NGXg\bh擾
  if ($method eq 'POST') {                         # POST삾...
    $clength = $ENV{'CONTENT_LENGTH'};             #   f[^擾
    error_abort("Posted data too big.($clength bytes)")
      if ($clength > $article_max);                #   f[^傫߂G[
    read(STDIN, $buffer, $clength);                #   W͂f[^擾
    push(@pairs, split(/&/, $buffer));             #   f[^ڃXgɒǉ
  }
  set_in(\@pairs);                                 # ڂƃf[^̃nbV쐬
  $ENV{'SCRIPT_NAME'} =~ m|^.*?([^/\._]+)_post\.cgi$|;  # eΏۃ{[h擾
  $in{'board'} = $1;
  $in{'note'} =~ s/\r+\Z//;                        # {̋s
  $in{'user'} = $ENV{'REMOTE_USER'};               # F؃[U擾
  if (0 < $in{'rno'} and $in{'rno'} < 999) {       # [e[gԍ擾,ݒ
    $rno = $in{'rno'} + 1;
  } else {
    $rno = 1;
  }

  open(FH, $boards_file)               # {[hݒt@CI[v
      or error_abort($!, "can't open $boards_file.");
  flock(FH, 2);
  $found = 0;
  while(<FH>) {                        # eΏۃ{[h̐ݒT
    if (m/^$in{'board'}=/) { $found = 1;  $buffer = $_;  last; }
  }
  close(FH);                           # {[hݒt@CN[Y
  error_abort("Board '$in{'board'}' is not found.")
      unless ($found);                 # Ȃ΃G[

  undef(@pairs);
  @pairs = split(/\s*,\s*/, $buffer);  # {[hݒڃXg
  $board = get_hash(\@pairs);          # ڂnbV
  $board_key = $board->{$in{'board'}}; # t@CL[

  $buffer = $ENV{'HTTP_COOKIE'};       # NbL[̓e擾
  undef(@pairs);
  @pairs = split(/;\s*/, $buffer);     # eNbL[ɕ
  $cookies = get_hash(\@pairs);        # SNbL[̃nbV
  undef(@pairs);
  @pairs = split(/&/, $cookies->{"bikke_$in{'board'}"});  # ړĨNbL[𕪊
  foreach $pair (@pairs) {             # ړĨ{[h̃NbL[lnbV
    ($key, $val) = ($pair =~ m/([^:]+):(.*)/);
    $val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;  # URIfR[h
    jcode::convert(\$val, 'sjis');     # R[hSJIS
    jcode::h2z_sjis(\$val);            # pJiSp
    $cookie{$key} = $val;
  }
  $cookie{'www'}  = $cookie{'www'}  || 'http://';  # ftHgl

  # {[h̃p[^ŃftHg㏑ݒ
  $data_dir = $board->{'data_dir'} if (defined($board->{'data_dir'}));
  $data_dir = '../' . $data_dir unless ($data_dir =~ m!^(/|[a-zA-Z]:)!);
  $title        = $board->{'title'}       if (defined($board->{'title'}));
  $datafile_backup = $board->{'data_backup'} if ($board->{'data_backup'});
  $datafile_max = $board->{'data_max'}    if ($board->{'data_max'});
  $archive      = $board->{'archive'}     if ($board->{'archive'});
  $archive_max  = $board->{'archive_max'} if ($board->{'archive_max'});
  $cookie_life  = $board->{'cookie_life'} if (defined($board->{'cookie_life'}));
  if (defined($board->{'mailing_cfg'})) {
    $mailing = 'on';
    $mailing_cfg = $board->{'mailing_cfg'};
    $mailing_cfg = "$data_dir/$mailing_cfg" # ΃pXȂdata_dir
      unless ($mailing_cfg =~ m!^(/|[a-zA-Z]:)!);
  }
  $bg_color    = $board->{'bg_color'}    if (defined($board->{'bg_color'}));
  $text_color  = $board->{'text_color'}  if (defined($board->{'text_color'}));
  $link_color  = $board->{'link_color'}  if (defined($board->{'link_color'}));
  $vlink_color = $board->{'vlink_color'} if (defined($board->{'vlink_color'}));
  $name_color  = $board->{'name_color'}  if (defined($board->{'name_color'}));
  $glay_color  = $board->{'glay_color'}  if (defined($board->{'glay_color'}));
}

# t@Cl[̐ݒ
my $titlefile_name  = "$in{'board'}_posttitle.html";  # ^Cgt@C
my $datafile_name   = "$data_dir/${board_key}_data.cgi";   # f[^t@C
my $new_datafile_name = "$data_dir/new_${board_key}_data.cgi"; # Vf[^t@C
my $old_datafile_name = "$data_dir/old_${board_key}_data.cgi"; # f[^t@C
my $archive_name    = "$data_dir/${board_key}_archive.cgi"; # A[JCut@C

# ==================== HTML \p̐ݒ =====================

# ----- HTTPwb_ ---------------
my $http_header = "Content-type: text/html\n\n";
# ----- NbL[ΉHTMLwb_ ---
my $html_header_cookie = <<"EOT";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
        "http://www.w3.org/TR/html4/loose.dtd">
<HTML LANG="ja">
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=shift_jis">
<TITLE>$title</TITLE>
<SCRIPT LANGUAGE="JavaScript">
function set_cookie() {
  var d = new Date();
  d.setTime(d.getTime() + 1000 * 60 * 60 * 24 * $cookie_life);
  document.cookie = 'bikke_$in{'board'}=' +
  'name:' + escape(document.inputform.name.value) + 
  '&mail:' + escape(document.inputform.mail.value) + 
  '&www:' + escape(document.inputform.www.value) + 
  '&delkey:' + escape(document.inputform.delkey.value) + 
  '; expires=' + d.toGMTString();
  alert('NbL[̐ݒ葀슮.');
}
</SCRIPT>
</HEAD>
EOT
# ----- ʏHTMLwb_ ---------
my $html_header = <<"EOT";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
        "http://www.w3.org/TR/html4/loose.dtd">
<HTML LANG="ja">
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=shift_jis">
<TITLE>$title</TITLE>
</HEAD>
EOT
# ----- NbL[ΉHTML<BODY> ---
my $html_body_cookie = qq!<BODY BGCOLOR="$bg_color" TEXT="$text_color" LINK="$link_color" VLINK="$vlink_color" onLoad="if(document.inputform.name.value.indexOf('%u') >= 0) document.inputform.name.value = unescape(document.inputform.name.value);">\n!;
# ----- ʏHTML<BODY> ---------
my $html_body = qq!<BODY BGCOLOR="$bg_color" TEXT="$text_color" LINK="$link_color" VLINK="$vlink_color">\n!;
# ----- HTML̏I -------------
my $html_end = "</BODY>\n</HTML>\n";
# ----- eptH[ -----------
my $input_form = <<"EOT";
<FORM METHOD="post" ACTION="$script_url" NAME="inputform" ID="inputform">
  <TABLE WIDTH="100%" BORDER="0">
    <TR> 
      <TD ALIGN="RIGHT"><LABEL FOR="name" ACCESSKEY="N"><B><FONT COLOR="$name_color">O</FONT></B></LABEL></TD>
      <TD><INPUT TYPE="text" NAME="name" SIZE="50" ID="name" VALUE="$cookie{'name'}"></TD>
    </TR>
    <TR> 
      <TD ALIGN="RIGHT"><LABEL FOR="mail" ACCESSKEY="M"><B><FONT COLOR="$name_color">[</FONT></B></LABEL></TD>
      <TD><INPUT TYPE="text" NAME="mail" SIZE="50" ID="mail" VALUE="$cookie{'mail'}"></TD>
    </TR>
    <TR> 
      <TD ALIGN="RIGHT"><LABEL FOR="www" ACCESSKEY="W"><B><FONT COLOR="$glay_color">WWWTCg</FONT></B></LABEL></TD>
      <TD><INPUT TYPE="text" NAME="www" SIZE="70" ID="www" VALUE="$cookie{'www'}"></TD>
    </TR>
    <TR> 
      <TD ALIGN="RIGHT"><LABEL FOR="subj" ACCESSKEY="S"><B>\\</B></LABEL></TD>
      <TD NOWRAP><INPUT TYPE="text" NAME="subj" SIZE="50" ID="subj">
      @<LABEL FOR="delkey" ACCESSKEY="D"><B><FONT COLOR="$glay_color">폜L[</FONT></B></LABEL>
        <INPUT TYPE="PASSWORD" NAME="delkey" SIZE="10" ID="delkey" VALUE="$cookie{'delkey'}"></TD>
    </TR>
    <TR> 
      <TD ALIGN="RIGHT"><LABEL FOR="note" ACCESSKEY="T"><B>{</B></LABEL></TD>
      <TD><TEXTAREA NAME="note" COLS="70" ROWS="5" WRAP="PHYSICAL" ID="note"></TEXTAREA></TD>
    </TR>
    <TR> 
      <TD ALIGN="RIGHT"><LABEL FOR="link" ACCESSKEY="U"><B><FONT COLOR="$glay_color">QURL</FONT></B></LABEL></TD>
      <TD><INPUT TYPE="text" NAME="link" SIZE="70" ID="link" VALUE="http://"></TD>
    </TR>
    <TR> 
      <TD ALIGN="RIGHT">@</TD>
      <TD>
        <INPUT TYPE="submit" VALUE="@@e@">
        <INPUT TYPE="RESET" VALUE="NA">
        @@<INPUT TYPE="button" VALUE="NbL[ݒ" onClick="set_cookie();">
        @@<A HREF="$bikke?board=$in{'board'}&rno=$rno">[ \\y[W ]</A>
      </TD>
    </TR>
  </TABLE>
  <INPUT TYPE="hidden" NAME="command" VALUE="Post">
  <INPUT TYPE="hidden" NAME="rno" VALUE="$rno">
</FORM>
EOT
# ----- u߂v{^ ----------------
my $back_button = qq!<P ALIGN="CENTER">[ <A HREF="JavaScript:history.back()">߂</A> ]</P>\n!;
# ----- BikkẽS -------------------
my $bikke_logo = qq!<P ALIGN="RIGHT"><B><FONT COLOR="#00458A" SIZE="+1">Bikke</FONT></B> Post Form for Bikke 2.7<BR><SMALL>by Yuji at 2003, OEKAKI-STREET</SMALL></P>\n!;

# ==================== C ======================================

if ($method eq 'POST') {                   # |XgȂ
  post();                                  #   e
  post_mail() if ($mailing eq 'on');       #   KvȂ烁[
  success();                               #   \
} else {                                   # GETȋjȂ
  disp();                                  #   etH[\
}
exit(0);                                   # I


# ==================== Tu[` Level 1 ========================

# -------------------- e ----------------------------------------
sub post {
  my ($article, $content, @pairs, $line);
  my ($no, $date, $newfile);

  foreach (qw(name mail subj note)) {  # Kvȗ܂Ă邩`FbN
    disp_html($posterror_file) if ($in{$_} eq '');
  }

  $date = get_datetime();              # ݂̓tƎ擾

  unless (-e $datafile_name) {  $newfile = 1;  }  # VKt@CtO
                        else {  $newfile = 0;  }
  if ($newfile) {                      # VKt@Cւ݂̏Ȃ...
    $no = 1;                           #   A[eBNԍ 1
  } else {                             # łȂ...
    open(OLDDATA, $datafile_name)      #   f[^t@CI[v
        or error_abort("can't open $datafile_name.");
    flock(OLDDATA, 2);                 #   t@CbN
    $line = <OLDDATA>;                 #   擪sǂݍ
    close(OLDDATA);                    #   f[^t@CN[Y
    @pairs = split(/"/, $line);        #   ڃXg
    $article = get_hash(\@pairs);      #   A[eBNpnbV
    if ( $in{'note'} ne $article->{'note'}  # Õf[^Ɠ`FbN
         or $in{'subj'} ne $article->{'subj'}
         or $in{'name'} ne $article->{'name'}
         or $in{'mail'} ne $article->{'mail'} ) {
      $no = $article->{'no'} + 1;      #   VKA[eBN̔ԍ𓾂
    } else { disp_html($posterror_file); }  # ȂG[
  }

  $in{'host'} = get_hostname();      # zXg擾
  # VKA[eBNۑpsf[^
  $content = sprintf(qq!no=$no"date=$date"host=%s"user=%s"name=%s"mail=%s"www=%s"link=%s"subj=%s"delkey=%s"note=%s!, @in{'host', 'user', 'name', 'mail', 'www', 'link', 'subj', 'delkey', 'note'});
  if ((-s $archive_name) >= $archive_max) {  # A[JCu傫߂G[
    error_abort("Archive file too big.", "Please contact board manager.",
                "{[hǗ҂ɘAĂ.");
  }
  if (-e "$new_datafile_name") {        # ʃvZXݒ`FbN
    error_abort("post method is busy.", "ݑ삪؂Ă܂.",
                "ԂuĂxĂ݂Ă.");
  }
  open(NEWDATA, ">$new_datafile_name")  # Vf[^t@C쐬
    or error_abort("can't create $new_datafile_name.");
  flock(NEWDATA, 2);                    # t@CbN
  print NEWDATA "$content\n";           # 擪ɐVKA[eBNۑ

  unless ($newfile) {                   # t@CȂ...
    open(OLDDATA, "$datafile_name")     #   t@CI[v
        or error_abort($!, "can't open $datafile_name");
    flock(OLDDATA, 2);                  #   t@CbN
    seek(OLDDATA, 0, 0);                #   t@C擪Ɂi΍j
    seek(NEWDATA, 0, 2);                #   VKt@CɁiVj
    while(<OLDDATA>) {                  #   Vt@CɓeRs[
      last if (tell(NEWDATA) > $datafile_max);  # őTCYz珑Ȃ
      print NEWDATA $_;                 #   Vt@C1s
    }
    close(OLDDATA);                     #   f[^t@CN[Y
  }
  close(NEWDATA);                       # Vf[^t@CN[Y
  unless ($newfile) {                   # t@C...
    if (lc($datafile_backup) eq 'on') {       # obNAbvtO'on'Ȃ
      unlink($old_datafile_name)                # obNAbv΍폜
        if (-e $old_datafile_name);
      rename($datafile_name, $old_datafile_name)    # t@C̖OύX
          or error_abort($!, "can't rename old $datafile_name.");
    } else {                                  # obNAbvtO'off'Ȃ
      unlink($datafile_name)                        # t@C폜
          or error_abort($!, "can't delete $datafile_name.");
    }
  }
  if ($archive eq 'on') {               # A[JCuL^tO'on'Ȃ
    open(ARC, ">>$archive_name")        # A[JCut@CǋLpɃI[v
      or error_abort("can't open $archive_name.");
    flock(ARC, 2);
    seek(ARC, 0, 2);                    # t@CɃV[Ni΍j
    print ARC "$content\n";             # A[JCuɐVKA[eBNۑ
    close(ARC);
  }
  rename("$new_datafile_name", $datafile_name)  # Vt@Cl[
      or error_abort("can't rename new $datafile_name.");
}

# -------------------- \ ----------------------------------------
sub disp {
  print $http_header, $html_header_cookie, $html_body_cookie;  # wb_o
  if (-e $titlefile_name) {                 # ^Cgt@C...
    open(TITLE_FILE, $titlefile_name)       #   t@CI[v
        or error_abort($!, "can't open $titlefile_name.");
    print <TITLE_FILE>;                     #   ^Cg̓eo
    close(TITLE_FILE);                      #   t@CN[Y
  } else {                                  # Ȃ...
    print "<H1>$title post form</H1>\n";    #   ftHg̃^Cg\
  }
  print $input_form;                        # eptH[\
  print "<HR>\n";
  print $bikke_logo;                        # BikkẽS\
  print $html_end;                          # HTMLI
}

# -------------------- [ ----------------------------------
sub post_mail {
  my($from, @to, @cc, @bcc, $body);

  open(CFG, $mailing_cfg) or error_abort($!, "cannot open $mailing_cfg");
  while(<CFG>) {                                # [ݒt@Cǂ
    if(m/^from:\s*(\S+)/i) { $from = $1; }      #   wb_ڂǂ
    elsif(m/^to:\s*(\S+)/i)  { push(@to, $1); }
    elsif(m/^cc:\s*(\S+)/i)  { push(@cc, $1); }
    elsif(m/^bcc:\s*(\S+)/i) { push(@bcc, $1); }
    elsif(m/^-/) { $body = join('', <CFG>); }   #   c͖{
  }
  close(CFG);
  error_abort('maling configration is not enough.',
              '[̐ݒ肪sł.') if($from eq '' or @to <= 0);
  jcode::convert(\$body, 'jis');               # {JISR[h
  foreach ('name', 'subj', 'note', 'link') {   # v[Xz_ϊ
    jcode::convert(\$in_text{$_}, 'jis');
    $body =~ s/%%%$_%%%/$in_text{$_}/;
  }
  $body =~ s/\n+\Z//;                          # {̋s
  open(MAIL, "| $sendmail -t -oi")             # sendmail ɏo
         or error_abort($!, "cannot open $sendmail.");
  print MAIL "From: $from\n";
  print MAIL 'To: '  . join(', ', @to) . "\n" if(@to > 0);
  print MAIL 'Cc: '  . join(', ', @cc) . "\n" if(@cc > 0);
  print MAIL 'Bcc: ' . join(', ', @bcc) . "\n" if(@bcc > 0);
  print MAIL "Subject: New article on board[$in{'board'}] with Bikke\n";
  print MAIL "\n";
  print MAIL "$body\n";
  close(MAIL);
}

# -------------------- bZ[W ------------------------------
sub success {
  print $http_header;
  print $html_header;
  print $html_body;
  print <<"EOT";
<H1>$title e</H1>
<P>@e͐ɏI܂B</P>
<P>@͂F؃[U[ƃpX[h̓uEUI܂ŋLĂ܂̂ŁAӂB</P>
<P>
  <A HREF="$bikke?board=$in{'board'}&rno=$rno">[ \\y[W ]</A>
  <A HREF="$script_url?rno=$rno">[ ey[W ]</A>
</P>
EOT
  print $html_end;
}
# ==================== Tu[` Level 2 ========================

# ----- ̓f[^ %in ɃZbg
# set_in(<ڃXg̎Q>);
# ex. set_in(\@list);
sub set_in {
  my ($pairs, $pair, $key, $val);
  $pairs = shift(@_);
  foreach $pair(@$pairs) {
    ($key, $val) = ($pair =~ m/([^=]+)=(.*)/);
    $val =~ tr/+/ /;                   # '+'Xy[XɃfR[h
    $val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;  # URIfR[h
    jcode::convert(\$val, 'sjis');     # R[hSJIS
    jcode::h2z_sjis(\$val);            # pJiSp
    $val =~ tr/\t//;                   # TAB폜
    $in_text{$key} = $val;             # v[eLXgf[^ۑ
    html_text(\$val);                  # HTMLpeLXg
    $in{$key} = $val;                  # nbVɒlZbg
  }
  $in{'note'} =~ s/\r\n/\r/g;          # DOSs<cr><lf><cr>
  $in{'note'} =~ tr/\n/\r/;            # UNIXs<lf><cr>
  $in_text{'note'} =~ s/\r\n/\n/g;     # DOSs<cr><lf><lf>
  $in_text{'note'} =~ tr/\r/\n/;       # Macs<cr><lf>
  foreach ('www', 'link') {            # URL̃ftHglr
    if ($in{$_} eq 'http://') { $in_text{$_} = $in{$_} = ''; }
  }
}

# ----- yAf[^̃XgănbVɃZbg
# get_hash(<ڃXg̎Q>);
# ex. get_hash(\@list);
# ߂l͐VɍnbV̎Q
sub get_hash {
  my ($hash, $pairs);
  $pairs = shift(@_);
  %$hash = map { m/([^=]+)=(.*)/ } @$pairs;  # ȂnbVɒlZbg
  return($hash);
}

# ----- HTMLpeLXg
sub html_text {
  my $val = shift(@_);

  $$val =~ s/&/&amp;/g;               # ^O̖
  $$val =~ s/"/&quot;/g;
  $$val =~ s/'/&#39;/g;
  $$val =~ s/</&lt;/g;
  $$val =~ s/>/&gt;/g;
  $$val =~ s/\t/&nbsp&nbsp;/g;        # TABXy[X2Rɕϊ
}

# ----- ݂̓tƎ\𓾂
sub get_datetime {
  my ($year, $month, $day, $hour, $min);

#  ($min, $hour, $day, $month, $year) = (localtime(time))[1, 2, 3, 4, 5];
  ($min, $hour, $day, $month, $year) = (gmtime(time-$tz*60*60))[1, 2, 3, 4, 5];
  $year += 1900;
  $month++;
  return sprintf("%04d/%02d/%02d %02d:%02d", $year, $month, $day, $hour, $min);
}

# ----- [gzXg𓾂
sub get_hostname {
  my ($addr, $host);

  $addr = $ENV{'REMOTE_ADDR'};
  $host = $ENV{'REMOTE_HOST'};
  if ($host eq '') {
    unless ($host = gethostbyaddr(pack('C4', split(/\./,$host)), 2)) {
      $host = $addr;
    }
  }
  return($host);
}


# ==================== Tu[` Level 3 ========================

# ----- G[\ďI
# error_abort(<bZ[W̃Xg>...);
# ex. error_abort("file not found!", "can't open $filename");
sub error_abort {
  my $message = shift(@_);
  print "Content-type: text/html\n\n";
  print "<HTML>\n<HEAD>\n<TITLE>Error on Bikke</TITLE>\n</HEAD>\n<BODY>\n";
  print "<H1>Error on Bikke : $message</H1>\n";  # ŏ̃bZ[W
  foreach (@_) {  print "<P>$_</P>\n";  }        # cS\
  print $back_button;                            # u߂v{^\
  print "</BODY>\n<HTML>";
  exit(0);
}

# ----- w HTML t@CuEUɑďI
# disp_html(<HTMLt@C>);
# ex. disp_html("posterror.html");
sub disp_html {
  my $file_name = shift(@_);
  open(FH, $file_name) or error_abort($!, "can't open $file_name.");
  print "Content-type: text/html\n\n";
  print <FH>;             # t@C̓eS\
  close(FH);
  exit(0);
}
